"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.patchCSSOM = void 0;
var paperclip_utils_1 = require("paperclip-utils");
var patchCSSOM = function (sheet, mutations, resolveUrl) {
    for (var _i = 0, mutations_1 = mutations; _i < mutations_1.length; _i++) {
        var action = mutations_1[_i].action;
        switch (action.kind) {
            case "DeleteRule": {
                sheet.deleteRule(action.index);
                break;
            }
            case "InsertRule": {
                try {
                    sheet.insertRule((0, paperclip_utils_1.stringifyCSSRule)(action.rule, { resolveUrl: resolveUrl }), action.index);
                }
                catch (e) {
                    // insert some filler to maintain sync
                    sheet.insertRule(".nil {}", action.index);
                    console.warn(e);
                }
                break;
            }
            case "ReplaceRule": {
                sheet.deleteRule(action.index);
                // defensive against cases where user writes bad selector code that is valid in PC
                try {
                    sheet.insertRule((0, paperclip_utils_1.stringifyCSSRule)(action.rule, { resolveUrl: resolveUrl }), action.index);
                }
                catch (e) {
                    // insert some filler to maintain sync
                    sheet.insertRule(".nil {}", action.index);
                    console.warn(e);
                }
                break;
            }
        }
    }
};
exports.patchCSSOM = patchCSSOM;
