import { UrlResolver } from "./native-renderer";
import { EngineDelegateEvent, VirtualNode, VirtualText, VirtualElement, VirtualFrame, LoadedPCData } from "paperclip-utils";
import { DOMFactory } from "./base";
declare type Box = {
    width: number;
    height: number;
    x: number;
    y: number;
};
export declare type Frame = {
    sourceUri: string;
    _importedStylesContainer: HTMLElement;
    _mainStylesContainer: HTMLElement;
    _mount: HTMLElement;
    stage: HTMLElement;
};
export declare type FramesRendererState = {
    uri: string;
    frames: Frame[];
    preview?: VirtualNode;
};
/**
 * splits a file out into frames that can be
 */
export declare class FramesRenderer {
    private _resolveUrl;
    private _dependencies;
    private _framesProxy;
    private _domFactory;
    private _store;
    private _imp;
    onChange: (state: FramesRendererState) => void;
    constructor(targetUri: string, _resolveUrl: (url: string) => string, domFactory: DOMFactory, connectState: (state: FramesRendererState) => void);
    getUrlResolver(): (url: string) => string;
    getDOMFactory(): DOMFactory;
    setUrlResolver(value: UrlResolver): void;
    setPreview(preview: VirtualNode): void;
    get targetUri(): string;
    getState(): FramesRendererState;
    private _onFramesProxyChange;
    initialize({ sheet, importedSheets, preview, allImportedSheetUris }: LoadedPCData): void;
    /**
     */
    handleEngineDelegateEvent: (event: EngineDelegateEvent) => void;
    getRects(): Record<string, Box>;
}
export declare const getFrameVirtualNode: (frame: Frame, frames: Frame[], preview: VirtualNode) => VirtualFrame;
export declare const getFrameBounds: (node: VirtualElement | VirtualText) => {
    width: number;
    height: number;
    x: number;
    y: number;
    title?: string;
    visible?: boolean;
};
export {};
