"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
var chai_1 = require("chai");
var paperclip_1 = require("paperclip");
describe(__filename + "#", function () {
    it("can render a simple frame", function () { return __awaiter(void 0, void 0, void 0, function () {
        var engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)({
                        "/entry.pc": "<div>\n          <style>\n            color: red;\n          </style>\n          Hello world\n        </div>"
                    })];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(function (ev) {
                        try {
                            renderer.handleEngineDelegateEvent(ev);
                        }
                        catch (e) {
                            console.error(e);
                        }
                    });
                    engine.open("/entry.pc");
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[0].stage.innerHTML)).to.eql("<div></div><div><style>._406d2856._406d2856 {color: red;} </style></div><div><div class=\"_80f4925f _pub-80f4925f _406d2856\"> Hello world </div></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("re-rendered updated content", function () { return __awaiter(void 0, void 0, void 0, function () {
        var engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)({
                        "/entry.pc": "<div>\n          Hello world\n        </div>"
                    })];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(function (ev) {
                        try {
                            renderer.handleEngineDelegateEvent(ev);
                        }
                        catch (e) {
                            console.error(e);
                        }
                    });
                    engine.open("/entry.pc");
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[0].stage.innerHTML)).to.eql("<div></div><div><style></style></div><div><div class=\"_80f4925f _pub-80f4925f\"> Hello world </div></div>");
                    engine.updateVirtualFileContent("/entry.pc", "span man");
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[0].stage.innerHTML)).to.eql("<div></div><div><style></style></div><div>span man</div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("renderes root children as multiple getState().frames", function () { return __awaiter(void 0, void 0, void 0, function () {
        var engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)({
                        "/entry.pc": "a<span>b</span>"
                    })];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    engine.open("/entry.pc");
                    (0, chai_1.expect)(renderer.getState().frames.length).to.eql(2);
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[0].stage.innerHTML)).to.eql("<div></div><div><style></style></div><div>a</div>");
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[1].stage.innerHTML)).to.eql("<div></div><div><style></style></div><div><span class=\"_80f4925f _pub-80f4925f\">b</span></div>");
                    // test update
                    engine.updateVirtualFileContent("/entry.pc", "a<span>c</span>");
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[0].stage.innerHTML)).to.eql("<div></div><div><style></style></div><div>a</div>");
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[1].stage.innerHTML)).to.eql("<div></div><div><style></style></div><div><span class=\"_80f4925f _pub-80f4925f\">c</span></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("main style is shared across all getState().frames", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<style>div {\n        color: red;\n      }</style><div>a</div><div>b</div>"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph)];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    engine.open("/entry.pc");
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[0].stage.innerHTML)).to.eql("<div></div><div><style>div._80f4925f {color: red;} </style></div><div><div class=\"_80f4925f _pub-80f4925f\">a</div></div>");
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[1].stage.innerHTML)).to.eql("<div></div><div><style>div._80f4925f {color: red;} </style></div><div><div class=\"_80f4925f _pub-80f4925f\">b</div></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    // it(`main sheet is updated when it changes`, () => {
    // });
    xit("fragments are rendered as their own frame");
    xit("fragment children can change");
    xit("imported sheet is removed when import is deleted");
    xit("imported sheets across multiple getState().frames when import changes");
    it("properly renders with protocol", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, renderer, engine;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "file:///entry.pc": "<img src=\"/file.jpeg\" />"
                    };
                    renderer = (0, utils_1.createMockFramesRenderer)("file:///entry.pc", function (url) {
                        return url.replace("file", "blah");
                    });
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph)];
                case 1:
                    engine = _a.sent();
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("file:///entry.pc")];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)(renderer.getState().frames.length).to.eql(1);
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[0].stage.innerHTML)).to.eql("<div></div><div><style></style></div><div><img class=\"_80f4925f _pub-80f4925f\" src=\"blah:///file.jpeg\"></img></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("renders fragments as a single frame", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, renderer, engine;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<fragment>a<span>b</span></fragment>"
                    };
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)(renderer.getState().frames.length).to.eql(1);
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[0].stage.innerHTML)).to.eql("<div></div><div><style></style></div><div><fragment class=\"_80f4925f _pub-80f4925f\">a<span class=\"_80f4925f _pub-80f4925f\">b</span></fragment></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("flattens nested fragments", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, renderer, engine;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<fragment><fragment>a<span>b</span></fragment></fragment>"
                    };
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)(renderer.getState().frames.length).to.eql(1);
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[0].stage.innerHTML)).to.eql("<div></div><div><style></style></div><div><fragment class=\"_80f4925f _pub-80f4925f\">a<span class=\"_80f4925f _pub-80f4925f\">b</span></fragment></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("can remove & add an element", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, renderer, engine;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<span />b"
                    };
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[0].stage.innerHTML)).to.eql("<div></div><div><style></style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    engine.updateVirtualFileContent("/entry.pc", "b");
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[0].stage.innerHTML)).to.eql("<div></div><div><style></style></div><div>b</div>");
                    engine.updateVirtualFileContent("/entry.pc", "<span />b");
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[0].stage.innerHTML)).to.eql("<div></div><div><style></style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Adds styles from imported module to new frame", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, renderer, engine;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<import src=\"/mod.pc\" />a",
                        "/mod.pc": "<style>a { color: blue }</style>"
                    };
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[0].stage.innerHTML)).to.eql("<div><style>a._c938aea3 {color: blue;} </style></div><div><style></style></div><div>a</div>");
                    engine.updateVirtualFileContent("/entry.pc", "<import src=\"/mod.pc\" /><span /><!-- @frame { } --><div />");
                    (0, chai_1.expect)((0, utils_1.trimWS)(renderer.getState().frames[1].stage.innerHTML)).to.eql("<div><style>a._c938aea3 {color: blue;} </style></div><div><style></style></div><div><div class=\"_80f4925f _pub-80f4925f\"></div></div>");
                    return [2 /*return*/];
            }
        });
    }); });
});
