"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var paperclip_1 = require("paperclip");
var utils_1 = require("./utils");
describe(__filename + "#", function () {
    it("Can render basic text", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "Hello World"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div></div><div><style></style></div><div>Hello World</div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Can render an element", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<a href='#'>abc</a>"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div></div><div><style></style></div><div><a class=\"_80f4925f _pub-80f4925f\" href=\"#\">abc</a></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Re-renders a basic text change", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "a"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div></div><div><style></style></div><div>a</div>");
                    return [4 /*yield*/, engine.updateVirtualFileContent("/entry.pc", "b")];
                case 3:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div></div><div><style></style></div><div>b</div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Re-renders a basic attribute change", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<span><div a=\"b\"></div></span>"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div></div><div><style></style></div><div><span class=\"_80f4925f _pub-80f4925f\"><div a=\"b\" class=\"_80f4925f _pub-80f4925f\"></div></span></div>");
                    return [4 /*yield*/, engine.updateVirtualFileContent("/entry.pc", "<span><div a=\"c\"></div></span>")];
                case 3:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div></div><div><style></style></div><div><span class=\"_80f4925f _pub-80f4925f\"><div a=\"c\" class=\"_80f4925f _pub-80f4925f\"></div></span></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Renders a basic style", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<style> a { color: blue; } </style><span></span>"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div></div><div><style>a._80f4925f {color: blue;} </style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Renders imported styles", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<import src=\"./module.pc\" /><style> a { color: blue; } </style><span></span>",
                        "/module.pc": "<style> a { color: black; } </style>"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div><style>a._139cec8e {color: black;} </style></div><div><style>a._80f4925f {color: blue;} </style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Removes styles if import is removed", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<import src=\"./module.pc\" /><style> a { color: blue; } </style><span></span>",
                        "/module.pc": "<style> a { color: black; } </style>"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div><style>a._139cec8e {color: black;} </style></div><div><style>a._80f4925f {color: blue;} </style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    return [4 /*yield*/, engine.updateVirtualFileContent("/entry.pc", "<style> a { color: blue; } </style><span></span>")];
                case 3:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div></div><div><style>a._80f4925f {color: blue;} </style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Adds styles if import is added", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "file:///entry.pc": "<style> a { color: blue; } </style><span></span>",
                        "file:///module.pc": "<style> a { color: black; } </style>"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("file:///entry.pc");
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("file:///entry.pc")];
                case 2:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div></div><div><style>a._80f4925f {color: blue;} </style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    return [4 /*yield*/, engine.updateVirtualFileContent("file:///entry.pc", "<import src=\"./module.pc\" /><style> a { color: blue; } </style><span></span>")];
                case 3:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div><style>a._139cec8e {color: black;} </style></div><div><style>a._80f4925f {color: blue;} </style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Adds styles if import is added of module that is already loaded", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<style> a { color: blue; } </style><span></span>",
                        "/module.pc": "<style> a { color: black; } </style>"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, engine.open("/module.pc")];
                case 3:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div></div><div><style>a._80f4925f {color: blue;} </style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    return [4 /*yield*/, engine.updateVirtualFileContent("/entry.pc", "<import src=\"./module.pc\" /><style> a { color: blue; } </style><span></span>")];
                case 4:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div><style>a._139cec8e {color: black;} </style></div><div><style>a._80f4925f {color: blue;} </style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Adds styles from dependency dependency", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<style> a { color: blue; } </style>a",
                        "/module.pc": "<style> a { color: black; } </style>",
                        "/module2.pc": "<style> a { color: orange; } </style>"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, engine.open("/module.pc")];
                case 3:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div></div><div><style>a._80f4925f {color: blue;} </style></div><div>a</div>");
                    return [4 /*yield*/, engine.updateVirtualFileContent("/entry.pc", "<import src=\"./module.pc\" /><style> a { color: blue; } </style><span></span>")];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, engine.updateVirtualFileContent("/module.pc", "<import src=\"./module2.pc\" /><style> a { color: black; } </style>")];
                case 5:
                    _a.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div><style>a._11a847ab {color: orange;} </style><style>a._139cec8e {color: black;} </style></div><div><style>a._80f4925f {color: blue;} </style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("styles that are _added_ before renderer initializes are rendered", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<style> a { color: blue; } </style>",
                        "/module.pc": "<style> a { color: black; } </style>"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _c.sent();
                    // const renderer = createMockFramesRenderer("/entry.pc");
                    // engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    // const renderer = createMockFramesRenderer("/entry.pc");
                    // engine.onEvent(renderer.handleEngineDelegateEvent);
                    _c.sent();
                    return [4 /*yield*/, engine.updateVirtualFileContent("/entry.pc", "<import src=\"./module.pc\" /><style> a { color: blue; } </style><span></span>")];
                case 3:
                    _c.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    _b = (_a = renderer).initialize;
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 4:
                    _b.apply(_a, [(_c.sent())]);
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div><style>a._139cec8e {color: black;} </style></div><div><style>a._80f4925f {color: blue;} </style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("styles that are _removed_ before renderer initializes are rendered", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    graph = {
                        "/entry.pc": "<import src=\"./module.pc\" /><style> a { color: blue; } </style><span></span><style> a { color: blue; } </style>",
                        "/module.pc": "<style> a { color: black; } </style>"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _c.sent();
                    // const renderer = createMockFramesRenderer("/entry.pc");
                    // engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    // const renderer = createMockFramesRenderer("/entry.pc");
                    // engine.onEvent(renderer.handleEngineDelegateEvent);
                    _c.sent();
                    return [4 /*yield*/, engine.updateVirtualFileContent("/entry.pc", "<style> a { color: blue; } </style><span></span>")];
                case 3:
                    _c.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    _b = (_a = renderer).initialize;
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 4:
                    _b.apply(_a, [(_c.sent())]);
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql("<div></div><div><style>a._80f4925f {color: blue;} </style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("removes styles", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    graph = {
                        "/entry.pc": "\n        <import src=\"./module-a.pc\" />\n        <import src=\"./module-b.pc\" />\n        <import src=\"./module-c.pc\" />\n        <import src=\"./module-d.pc\" />\n        a\n      ",
                        "/module-a.pc": "<style> a { color: a; } </style>",
                        "/module-b.pc": "<style> a { color: b; } </style>",
                        "/module-c.pc": "<style> a { color: c; } </style>",
                        "/module-d.pc": "<style> a { color: d; } </style>"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _c.sent();
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _c.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    _b = (_a = renderer).initialize;
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 3:
                    _b.apply(_a, [(_c.sent())]);
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    (0, chai_1.expect)(combineFrameHTML(renderer).replace(/\n/g, "")).to.eql("<div><style>a._61a60758 {color: a;} </style><style>a._7313a8b6 {color: b;} </style><style>a._cbafcfd3 {color: c;} </style><style>a._5678f76a {color: d;} </style></div><div><style></style></div><div> a </div>");
                    return [4 /*yield*/, engine.updateVirtualFileContent("/entry.pc", "\n     <import src=\"./module-b.pc\" />\n     <import src=\"./module-d.pc\" />a\n     ")];
                case 4:
                    _c.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer).replace(/\n/g, "")).to.eql("<div><style>a._7313a8b6 {color: b;} </style><style>a._5678f76a {color: d;} </style></div><div><style></style></div><div>a </div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Properly replaces elements", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer, _a, _b, renderer2, _c, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    graph = {
                        "/entry.pc": "\n      <div export component as=\"StyledHeader\" \n        class=\"StyledHeader\"\n        {onClick?}\n        > \n      </div>\n      \n      <div export component as=\"Preview\">\n        <StyledHeader {depth?} {open?}>\n        </StyledHeader>\n      </div>\n      \n      <preview noPadding>\n        <Preview>\n        </Preview>\n      \n        <StyledHeader open>\n          Content\n        </StyledHeader>\n      </preview>"
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _e.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    _b = (_a = renderer).initialize;
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _b.apply(_a, [(_e.sent())]);
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.updateVirtualFileContent("file:///entry.pc", "\n\n  <div export component as=\"StyledHeader\" \n    class=\"StyledHeader\"\n    {onClick?}\n    > \n  </div>\n\n  <div export component as=\"Preview\">\n    <StyledHeader {depth?} {open?}>\n    </StyledHeader>\n  </div>\n\n  <preview noPadding>\n    <Preview header=\"Header\">\n    </Preview>\n\n    <Preview header=\"Header\">\n      Content\n    </Preview>\n  </preview>\n    ")];
                case 3:
                    _e.sent();
                    renderer2 = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    _d = (_c = renderer2).initialize;
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 4:
                    _d.apply(_c, [(_e.sent())]);
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    (0, chai_1.expect)(combineFrameHTML(renderer)).not.to.eql(undefined);
                    (0, chai_1.expect)(combineFrameHTML(renderer)).to.eql(combineFrameHTML(renderer2));
                    return [2 /*return*/];
            }
        });
    }); });
    it("Properly renders with a protocol", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    graph = {
                        "file:///entry.pc": "\n        <img src=\"/file.jpg\" />\n      ",
                        "file:///file.jpg": "",
                        "file:///something-else.jpg": ""
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _c.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("file:///entry.pc", function (url) { return url.replace("file:", "blah:"); });
                    _b = (_a = renderer).initialize;
                    return [4 /*yield*/, engine.open("file:///entry.pc")];
                case 2:
                    _b.apply(_a, [(_c.sent())]);
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    (0, chai_1.expect)(combineFrameHTML(renderer)
                        .replace("\n", "")
                        .replace(/\\+/g, "/")).to.eql("<div></div><div><style></style></div><div><img class=\"_80f4925f _pub-80f4925f\" src=\"blah:///file.jpg\"></img></div>");
                    engine.updateVirtualFileContent("file:///entry.pc", "\n      <img src=\"./something-else.jpg\" />\n    ");
                    (0, chai_1.expect)(combineFrameHTML(renderer)
                        .replace("\n", "")
                        .replace(/\\/g, "/Z/")).to.eql("<div></div><div><style></style></div><div><img class=\"_80f4925f _pub-80f4925f\" src=\"blah:///something-else.jpg\"></img></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Treats doesn't remove previous class if class is set", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    graph = {
                        "file:///entry.pc": "\n        \n        <span class=\"a\">\n        </span>\n      "
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _c.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("file:///entry.pc", function (url) {
                        return url.replace("file", "blah");
                    });
                    _b = (_a = renderer).initialize;
                    return [4 /*yield*/, engine.open("file:///entry.pc")];
                case 2:
                    _b.apply(_a, [(_c.sent())]);
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    (0, chai_1.expect)(combineFrameHTML(renderer)
                        .replace("\n", "")
                        .replace(/\\+/g, "/")).to.eql("<div></div><div><style></style></div><div><span class=\"_80f4925f_a _pub-80f4925f_a a _80f4925f _pub-80f4925f\"></span></div>");
                    engine.updateVirtualFileContent("file:///entry.pc", "<span class=\"a\" class>\n      </span>\n    ");
                    (0, chai_1.expect)(combineFrameHTML(renderer)
                        .replace("\n", "")
                        .replace(/\\/g, "/Z/")).to.eql("<div></div><div><style></style></div><div><span class=\"_80f4925f _pub-80f4925f\"></span></div>");
                    engine.updateVirtualFileContent("file:///entry.pc", "<span class:a=\"a\" class=\"b\">\n      </span>\n    ");
                    (0, chai_1.expect)(combineFrameHTML(renderer)
                        .replace("\n", "")
                        .replace(/\\/g, "/Z/")).to.eql("<div></div><div><style></style></div><div><span class=\"_80f4925f_b _pub-80f4925f_b b _80f4925f _pub-80f4925f\"></span></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Properly replaces rule", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    graph = {
                        "file:///entry.pc": "\n        <style>\n          .a {\n            color: red;\n          }\n          .b {\n            color: orange;\n            @media screen and (max-width: 100px) {\n              color: blue;\n            }\n          }\n          @keyframes {\n            0% {\n              color: blue;\n            }\n            100% {\n              color: black;\n            }\n          }\n        </style>\n        <div></div>\n      "
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _c.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("file:///entry.pc");
                    _b = (_a = renderer).initialize;
                    return [4 /*yield*/, engine.open("file:///entry.pc")];
                case 2:
                    _b.apply(_a, [(_c.sent())]);
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    (0, chai_1.expect)(combineFrameHTML(renderer)
                        .replace("\n", "")
                        .replace(/\\+/g, "/")).to.eql("<div></div><div><style>[class]._80f4925f_a {color: red;} [class]._80f4925f_b {color: orange;} @media screen and (max-width: 100px) {[class]._80f4925f_b {color: blue;}} @keyframes _80f4925f_ {    0% {color: blue;}    100% {color: black;}  } </style></div><div><div class=\"_80f4925f _pub-80f4925f\"></div></div>");
                    engine.updateVirtualFileContent("file:///entry.pc", "<style>\n      .d {\n        color: orange;\n      }\n  </style>\n  <div></div>");
                    (0, chai_1.expect)(combineFrameHTML(renderer)
                        .replace("\n", "")
                        .replace(/\\+/g, "/")).to.eql("<div></div><div><style>[class]._80f4925f_d {color: orange;} </style></div><div><div class=\"_80f4925f _pub-80f4925f\"></div></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Properly inserts rule", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    graph = {
                        "file:///entry.pc": "\n        <style>\n          .a {\n            color: red;\n          }\n        </style>\n        <div></div>\n      "
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _c.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("file:///entry.pc");
                    _b = (_a = renderer).initialize;
                    return [4 /*yield*/, engine.open("file:///entry.pc")];
                case 2:
                    _b.apply(_a, [(_c.sent())]);
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    (0, chai_1.expect)(combineFrameHTML(renderer)
                        .replace("\n", "")
                        .replace(/\\+/g, "/")).to.eql("<div></div><div><style>[class]._80f4925f_a {color: red;} </style></div><div><div class=\"_80f4925f _pub-80f4925f\"></div></div>");
                    engine.updateVirtualFileContent("file:///entry.pc", "<style>\n      .a {\n        color: red;\n      }\n      .b {\n        color: blue;\n      }\n  </style>\n  <div></div>");
                    (0, chai_1.expect)(combineFrameHTML(renderer)
                        .replace("\n", "")
                        .replace(/\\+/g, "/")).to.eql("<div></div><div><style>[class]._80f4925f_a {color: red;} [class]._80f4925f_b {color: blue;} </style></div><div><div class=\"_80f4925f _pub-80f4925f\"></div></div>");
                    return [2 /*return*/];
            }
        });
    }); });
    it("Ignores frames from unrelated files", function () { return __awaiter(void 0, void 0, void 0, function () {
        var graph, engine, renderer, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    graph = {
                        "file:///main.pc": "\n        <import src=\"./test.pc\" as=\"test\" />\n\n        <style>\n          @font-face {\n            font-family: \"Eina\";\n            src: url('./Eina03-Regular.woff');\n          }\n        </style>\n        \n        \n        <!--\n          @frame { width: 365, height: 194, x: 0, y: 0 }\n        -->\n        <div>\n          <style>\n            font-family: Eina;\n          </style>\n          Hello dawggg\n          <test.Test>\n            Hello world\n          </test.Test>\n        </div>\n      ",
                        "file:///test.pc": "\n      <!--\n        @frame { visible: false }\n      -->\n      <div export component as=\"Test\">\n        <style>\n          font-family: sans-serif;\n          color: rgb(100, 172, 86);\n          font-size: 24px;\n        </style>\n        {children}\n      </div>\n      \n      \n      <!--\n        @frame { width: 346, height: 203, x: 0, y: 0 }\n      -->\n      <Test>\n        Hello world\n      </Test>\n      "
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngineDelegate)(graph, paperclip_1.EngineMode.MultiFrame)];
                case 1:
                    engine = _c.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("file:///test.pc");
                    _b = (_a = renderer).initialize;
                    return [4 /*yield*/, engine.open("file:///test.pc")];
                case 2:
                    _b.apply(_a, [(_c.sent())]);
                    return [4 /*yield*/, engine.open("file:///main.pc")];
                case 3:
                    _c.sent();
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.updateVirtualFileContent("file:///main.pc", "")];
                case 4:
                    _c.sent();
                    (0, chai_1.expect)(combineFrameHTML(renderer)
                        .replace("\n", "")
                        .replace(/\\+/g, "/")).to.eql("<div></div><div><style>._a0539270._a0539270 {font-family: sans-serif; color: rgb(100, 172, 86); font-size: 24px;} </style></div><div><div class=\"_6bcf0994 _pub-6bcf0994 _a0539270\"> Hello world </div></div>");
                    return [2 /*return*/];
            }
        });
    }); });
});
var combineFrameHTML = function (renderer) {
    return renderer
        .getState()
        .frames.map(function (frame) { return frame.stage.innerHTML; })
        .join("");
};
