"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateStyleElement = void 0;
var utils_1 = require("./utils");
var generateStyleElement = function (options, context) {
    var buffer = "<style>";
    buffer += (0, utils_1.randomArray)(options.minWidth, options.maxWidth)
        .map(function () { return generateCSSRule(options, context); })
        .join("\n");
    return buffer + "</style>";
};
exports.generateStyleElement = generateStyleElement;
var generateCSSRule = function (options, context) {
    return (0, utils_1.pickRandom)([generateCSSStyleRule, generateCSSMediaRule])(options, context);
};
var generateCSSMediaRule = function (options, context) {
    return ("@media ".concat((0, utils_1.randomChars)(1, 5, 5), " {\n") +
        "  ".concat((0, utils_1.randomArray)(options.minWidth, options.maxWidth)
            .map(function () {
            return generateCSSStyleRule(options, __assign(__assign({}, context), { depth: context.depth + 1 }));
        })
            .join("\n")) +
        "}\n\n");
};
var generateCSSStyleRule = function (options, context) {
    return (".".concat((0, utils_1.randomChars)(1, 5, 5), " {\n") +
        " ".concat((0, utils_1.randomArray)(options.minWidth, options.maxWidth)
            .map(function () {
            return (0, utils_1.pickRandom)(context.depth < options.maxDepth
                ? [generateCSSSDeclaration, generateCSSStyleRule]
                : [generateCSSSDeclaration])(options, __assign(__assign({}, context), { depth: context.depth + 1 }));
        })
            .join("\n")) +
        "}\n\n");
};
var generateCSSSDeclaration = function (options, context) {
    // don't want to be totally random
    return "".concat((0, utils_1.randomChars)(1, 4, 3), ": ").concat((0, utils_1.randomChars)(1, 4), ";");
};
utils_1.randomChars;
