"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.pickRandom = exports.randomArray = exports.randomChars = void 0;
var lodash_1 = require("lodash");
var AZRANGE = 123 - 97;
var A2Z = Array.from({ length: AZRANGE }).map(function (v, i) {
    return String.fromCharCode(i + 97);
});
var randomChars = function (min, max, range) {
    if (range === void 0) { range = AZRANGE; }
    var azOptions = A2Z.slice(0, range);
    return (0, exports.randomArray)(min, max)
        .map(function () { return (0, exports.pickRandom)(azOptions); })
        .join("");
};
exports.randomChars = randomChars;
var randomArray = function (min, max) {
    return Array.from({ length: (0, lodash_1.clamp)(Math.round(Math.random() * max), min, max) });
};
exports.randomArray = randomArray;
var pickRandom = function (options, weights) {
    if (!weights) {
        weights = Array.from({ length: options.length }).map(function () { return 1; });
    }
    var weightedOptions = options.reduce(function (weightedOptions, option, index) {
        return __spreadArray(__spreadArray([], weightedOptions, true), Array.from({ length: weights[index] }).map(function () {
            return option;
        }), true);
    }, []);
    return weightedOptions[Math.floor(Math.random() * weightedOptions.length)];
};
exports.pickRandom = pickRandom;
