"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.trimWS = exports.createMockFramesRenderer = exports.createMockEngineDelegate = exports.createMockEngine = exports.mockDOMFactory = void 0;
var paperclip_1 = require("paperclip");
var path = require("path");
var frame_renderer_1 = require("../frame-renderer");
var paperclip_2 = require("paperclip");
var lodash_1 = require("lodash");
var CSSOM = require("cssom");
exports.mockDOMFactory = {
    createElement: function (tagName) {
        if (tagName === "style") {
            return new StyleElement();
        }
        return new MockElement(tagName);
    },
    createElementNS: function (tagName) { return new MockElement(tagName); },
    createDocumentFragment: function () { return new MockFragment(); },
    createTextNode: function (nodeValue) { return new MockTextNode(nodeValue); }
};
var BaseNode = /** @class */ (function () {
    function BaseNode() {
    }
    BaseNode.prototype.remove = function () {
        this.$$parent.removeChild(this);
    };
    Object.defineProperty(BaseNode.prototype, "parentNode", {
        get: function () {
            return this.$$parent;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseNode.prototype, "innerHTML", {
        get: function () {
            return this.getInnerHTML();
        },
        enumerable: false,
        configurable: true
    });
    return BaseNode;
}());
var ParentNode = /** @class */ (function (_super) {
    __extends(ParentNode, _super);
    function ParentNode() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.childNodes = [];
        return _this;
    }
    ParentNode.prototype.appendChild = function (child) {
        var _a;
        var _this = this;
        child.$$parent = this;
        if (child instanceof MockFragment) {
            child.childNodes.forEach(function (child) {
                child.$$parent = _this;
            });
            (_a = this.childNodes).push.apply(_a, child.childNodes);
        }
        else {
            this.childNodes.push(child);
        }
    };
    ParentNode.prototype.removeChild = function (child) {
        child.$$parent = null;
        this.childNodes.splice(this.childNodes.indexOf(child), 1);
    };
    ParentNode.prototype.insertBefore = function (child, ref) {
        var _a;
        var index = this.childNodes.indexOf(ref);
        if (index === -1) {
            throw new Error("ref not found");
        }
        var children = child instanceof MockFragment ? child.childNodes : [child];
        for (var _i = 0, children_1 = children; _i < children_1.length; _i++) {
            var child_1 = children_1[_i];
            child_1.$$parent = this;
        }
        (_a = this.childNodes).splice.apply(_a, __spreadArray([index, 0], children, false));
    };
    ParentNode.prototype.getInnerHTML = function () {
        var buffer = "";
        for (var _i = 0, _a = this.childNodes; _i < _a.length; _i++) {
            var child = _a[_i];
            buffer += child.toString();
        }
        return buffer;
    };
    return ParentNode;
}(BaseNode));
var StyleElement = /** @class */ (function (_super) {
    __extends(StyleElement, _super);
    function StyleElement() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(StyleElement.prototype, "textContent", {
        get: function () {
            return this._textContent;
        },
        set: function (value) {
            this._textContent = value;
            this._sheet = CSSOM.parse(value);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(StyleElement.prototype, "sheet", {
        get: function () {
            return this._sheet;
        },
        enumerable: false,
        configurable: true
    });
    StyleElement.prototype.cloneNode = function () {
        var el = new StyleElement();
        el.textContent = this.sheet.toString();
        return el;
    };
    StyleElement.prototype.toString = function () {
        return "<style>".concat(this._sheet.toString().replace(/\n+/g, " "), "</style>");
    };
    return StyleElement;
}(ParentNode));
var MockElement = /** @class */ (function (_super) {
    __extends(MockElement, _super);
    function MockElement(tagName) {
        var _this = _super.call(this) || this;
        _this.tagName = tagName;
        _this.attributes = {};
        _this.style = {};
        _this.textContent = "";
        return _this;
    }
    MockElement.prototype.setAttribute = function (name, value) {
        this.attributes[name] = value;
    };
    MockElement.prototype.cloneNode = function () {
        var el = new MockElement(this.tagName);
        for (var key in this.attributes) {
            el.setAttribute(key, el.attributes[key]);
        }
        el.textContent = this.textContent;
        for (var _i = 0, _a = this.childNodes; _i < _a.length; _i++) {
            var child = _a[_i];
            el.appendChild(child.cloneNode());
        }
        return el;
    };
    // eslint-disable-next-line
    MockElement.prototype.addEventListener = function () { };
    MockElement.prototype.removeAttribute = function (name) {
        delete this.attributes[name];
    };
    MockElement.prototype.toString = function () {
        var _this = this;
        var buffer = "<".concat(this.tagName);
        var sortedAttributes = Object.keys(this.attributes)
            .sort()
            .map(function (name) { return ({ name: name, value: _this.attributes[name] }); });
        for (var _i = 0, sortedAttributes_1 = sortedAttributes; _i < sortedAttributes_1.length; _i++) {
            var _a = sortedAttributes_1[_i], name_1 = _a.name, value = _a.value;
            if (!value) {
                continue;
            }
            buffer += " ".concat(name_1, "=").concat(JSON.stringify(value));
        }
        buffer += ">";
        buffer +=
            this.getInnerHTML() || this.textContent.replace(/[\s\r\n\t]+/g, " ");
        buffer += "</".concat(this.tagName, ">");
        return buffer;
    };
    return MockElement;
}(ParentNode));
var MockFragment = /** @class */ (function (_super) {
    __extends(MockFragment, _super);
    function MockFragment() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MockFragment.prototype.cloneNode = function () {
        var clone = new MockFragment();
        for (var _i = 0, _a = this.childNodes; _i < _a.length; _i++) {
            var child = _a[_i];
            clone.appendChild(child.cloneNode());
        }
        return clone;
    };
    MockFragment.prototype.toString = function () {
        return "";
    };
    return MockFragment;
}(ParentNode));
var MockTextNode = /** @class */ (function (_super) {
    __extends(MockTextNode, _super);
    function MockTextNode(nodeValue) {
        var _this = _super.call(this) || this;
        _this.nodeValue = nodeValue;
        return _this;
    }
    MockTextNode.prototype.cloneNode = function () {
        return new MockTextNode(this.nodeValue);
    };
    MockTextNode.prototype.getInnerHTML = function () {
        return this.toString();
    };
    MockTextNode.prototype.toString = function () {
        return this.nodeValue;
    };
    return MockTextNode;
}(BaseNode));
var createMockEngine = function (graph) {
    return (0, paperclip_1.createEngineDelegate)({
        io: {
            readFile: function (uri) {
                return graph[uri.replace("file://", "")] || graph[uri.replace(/\\+/g, "/")];
            },
            fileExists: function (uri) {
                return Boolean(graph[uri.replace("file://", "")] || graph[uri.replace(/\\+/g, "/")]);
            },
            resolveFile: function (from, to) {
                var prefix = from.indexOf("file:") === 0 ? "file://" : "";
                return (prefix +
                    path
                        .join(path.dirname(from.replace("file://", "")), to)
                        .replace(/\\+/g, "/"));
            }
        }
    });
};
exports.createMockEngine = createMockEngine;
var createMockEngineDelegate = function (graph, mode) {
    if (mode === void 0) { mode = paperclip_2.EngineMode.SingleFrame; }
    return (0, paperclip_1.createEngineDelegate)({
        io: {
            readFile: function (uri) {
                return graph[uri.replace("file://", "")] || graph[uri.replace(/\\+/g, "/")];
            },
            fileExists: function (uri) {
                return Boolean(graph[uri.replace("file://", "")] || graph[uri.replace(/\\+/g, "/")]);
            },
            resolveFile: function (from, to) {
                var prefix = from.indexOf("file:") === 0 ? "file://" : "";
                return (prefix +
                    path
                        .join(path.dirname(from.replace("file://", "")), to)
                        .replace(/\\+/g, "/"));
            }
        },
        mode: mode
    });
};
exports.createMockEngineDelegate = createMockEngineDelegate;
var createMockFramesRenderer = function (uri, resolveUrl) {
    if (uri === void 0) { uri = ""; }
    if (resolveUrl === void 0) { resolveUrl = lodash_1.identity; }
    return new frame_renderer_1.FramesRenderer(uri, resolveUrl, exports.mockDOMFactory, noop);
};
exports.createMockFramesRenderer = createMockFramesRenderer;
// eslint-disable-next-line
var noop = function () { };
var trimWS = function (str) { return str.replace(/[\s\r\n\t]+/g, " "); };
exports.trimWS = trimWS;
