"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var random_1 = require("./random");
var chai_1 = require("chai");
var utils_1 = require("./utils");
var lodash_1 = require("lodash");
describe(__filename + "#", function () {
    xit("passes the fuzzy test", function () { return __awaiter(void 0, void 0, void 0, function () {
        var randOptions, currentDocumentSource, graph, engine, renderer, i, randomDocument, baselineEngine, baselineRenderer, i_1, length_1, frameA, frameB, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    randOptions = {
                        minWidth: 1,
                        maxWidth: 4,
                        minDepth: 1,
                        maxDepth: 4
                    };
                    currentDocumentSource = (0, random_1.generateRandomPaperclipDocument)(randOptions);
                    graph = {
                        "/entry.pc": currentDocumentSource
                    };
                    return [4 /*yield*/, (0, utils_1.createMockEngine)(graph)];
                case 1:
                    engine = _a.sent();
                    renderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    engine.onEvent(renderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, engine.open("/entry.pc")];
                case 2:
                    _a.sent();
                    i = 50;
                    _a.label = 3;
                case 3:
                    if (!i--) return [3 /*break*/, 10];
                    randomDocument = (0, random_1.generateRandomPaperclipDocument)(randOptions);
                    // too lazy to fix
                    if (!randomDocument.trim()) {
                        return [3 /*break*/, 9];
                    }
                    return [4 /*yield*/, (0, utils_1.createMockEngine)({
                            "/entry.pc": randomDocument
                        })];
                case 4:
                    baselineEngine = _a.sent();
                    _a.label = 5;
                case 5:
                    _a.trys.push([5, 8, , 9]);
                    baselineRenderer = (0, utils_1.createMockFramesRenderer)("/entry.pc");
                    baselineEngine.onEvent(baselineRenderer.handleEngineDelegateEvent);
                    return [4 /*yield*/, baselineEngine.open("/entry.pc")];
                case 6:
                    _a.sent();
                    return [4 /*yield*/, engine.updateVirtualFileContent("/entry.pc", randomDocument)];
                case 7:
                    _a.sent();
                    (0, chai_1.expect)(renderer.getState().frames.length).to.eql(baselineRenderer.getState().frames.length);
                    for (i_1 = 0, length_1 = renderer.getState().frames.length; i_1 < length_1; i_1++) {
                        frameA = renderer.getState().frames[i_1];
                        frameB = baselineRenderer.getState().frames[i_1];
                        (0, chai_1.expect)(frameA._mount.innerHTML).to.eql(frameB._mount.innerHTML);
                    }
                    currentDocumentSource = randomDocument;
                    return [3 /*break*/, 9];
                case 8:
                    e_1 = _a.sent();
                    console.error("Fuzzy test failed to diff & patch:\n");
                    console.error((0, lodash_1.repeat)("-", 80));
                    console.error(currentDocumentSource);
                    console.error((0, lodash_1.repeat)("-", 80));
                    console.error((0, lodash_1.repeat)("-", 37) + " into " + (0, lodash_1.repeat)("-", 37));
                    console.error((0, lodash_1.repeat)("-", 80));
                    console.error(randomDocument);
                    console.error((0, lodash_1.repeat)("-", 80));
                    throw e_1;
                case 9: return [3 /*break*/, 3];
                case 10: return [2 /*return*/];
            }
        });
    }); });
});
